import argparse

def say_hi():
	parser = argparse.ArgumentParser()
	parser.add_argument('--name', action=nameAction)
	args = parser.parse_args()
	if args.name is None:
	    args.name = raw_input("Hi! What's your name? ")
	    nameAction.validate(parser, args.name)
	print('Hi, ' + args.name)

class nameAction(argparse.Action):
    def __call__(self, parser, namespace, value, option_string=None):
        self.validate(parser, value)
        setattr(namespace, self.dest, value)
    @staticmethod
    def validate(parser, value):
        if len(value) == 0:
            parser.error('{} not valid name'.format(value))